close all;
clc;
%%Aquisicao dos dados
filePath = 'G:\Drives compartilhados\Disciplina Fundamentos de Controle - SEL0417\Aula1\DadosMotor\';  %Colocar caminho dos arquivos .csv
ch1Table = readtable([filePath 'F0001CH1.csv']); %Corrente
ch2Table = readtable([filePath 'F0001CH2.csv']); %Velocidade
currentAtten = table2array(ch1Table(15,2));
velocityAtten = table2array(ch2Table(15,2));

Ts = table2array(ch1Table(2,2)); %Sample Time, presente no arquivo .csv importado do osciloscpio.

currentValue =  table2array(ch1Table(1:end,5));
currentTime =  table2array(ch1Table(1:end,4));
velocityValue =  table2array(ch2Table(1:end,5));
velocityTime = currentTime;

%Parmetros iniciais
Ktg = 0.1504; %Valor da constante que relaciona a tenso de sada do tacogerador e a velocidade do eixo.
Rext = 0.47; %Resitor utilizado para medir corrente
Vstep = 12.28; %Degrau de tenso aplicado na entrada.

current = currentAtten*currentValue/Rext; %A
velocity = velocityAtten*velocityValue/Ktg; %rad/s

%Tratando tamanho dos vetores para o degrau
Ia = current(193:end);
Omega = velocity(193:end);
Va  = [zeros(0,1);Vstep*ones(length(Omega),1)];
%Adequa tempo s amostras
time = linspace(Ts,Ts*size(Omega,1),size(Omega,1));
time = time';

Wmed=[time Omega];      %Velocidade medida do degrau rad/s
Vamed=[time Va];      %Tensao de armadura Volts
Iamed=[time Ia];      %Corrente de armadura Volts

%%
%ident 

motor = iddata;
motor.Tstart = 0;
motor.Ts = Ts;
motor.InputData = Va;
motor.OutputData = Omega;

%chamar a interface grfica: ident pi usar tfest
tfmotor1pole = tfest(motor,1,0);
tfmotor2pole = tfest(motor,2,0);
figure
step(Vstep*tfmotor1pole);
hold
plot(time,Omega);
figure
step(Vstep*tfmotor2poles);
hold
plot(time,Omega);


%%
%Parameter Estimation
%Chute inicial dos parmetros do motor
Ra = 0.1501; % Resistncia de armadura [Ohm]
La = 0.000150;  % Indutncia de armadura [H]
K = 0.087;  % Kt=Ke para este motor: Constante de torque [N-m/A] ou Constante f.c.e.m [V-s/rad]
J = 0.00050804; % Momento de inrcia [N-m-s^2/rad]
B = 0.0006; % Coeficiente de atrito viscoso [N-m-s/rad]
run('SimulacaoMotorCC_r2016a');

%%
Kt = K;
Ke = K;
s = tf('s');
Gm = Kt/(La*J*s^2+(Ra*J+La*B)*s+(Ra*B+Ke*Kt));

tau_a = La/Ra;
tau_b = J/B;
tau_m = (Ra*J)/(Ke*Kt);
Gm2 = (1/(Ke*tau_m*tau_a))/(s^2 +(1/tau_a + 1/tau_b)*s + 1/(tau_m*tau_a) +1/(tau_a*tau_b) );

 