close all;
clc;
clear;
%%Aquisicao dos dados
filePath = 'G:\Drives compartilhados\Disciplina Fundamentos de Controle - SEL0417\Aula1\Material do aluno\DadosMotor\';  %Colocar caminho dos arquivos .csv
ch1Table = readtable([filePath 'F0001CH1.csv']); %Corrente
ch2Table = readtable([filePath 'F0001CH2.csv']); %Velocidade
currentAtten = table2array(ch1Table(15,2));
velocityAtten = table2array(ch2Table(15,2));

Ts = table2array(ch1Table(2,2)); %Sample Time, presente no arquivo .csv importado do osciloscópio.

currentValue =  table2array(ch1Table(1:end,5));
currentTime =  table2array(ch1Table(1:end,4));
velocityValue =  table2array(ch2Table(1:end,5));
velocityTime = currentTime;

%Parâmetros iniciais
Ktg = 0.1504; %Valor da constante que relaciona a tensão de saída do tacogerador e a velocidade do eixo.
Rext = 0.47; %Resitor utilizado para medir corrente
Vstep = 12.28; %Degrau de tensão aplicado na entrada.

current = currentAtten*currentValue/Rext; %A
velocity = velocityAtten*velocityValue/Ktg; %rad/s

%Tratando tamanho dos vetores para o degrau
Ia = current(193:end);
Omega = velocity(193:end);
Va  = [zeros(0,1);Vstep*ones(length(Omega),1)];
%Adequa tempo às amostras
time = linspace(Ts,Ts*size(Omega,1),size(Omega,1));
time = time';

Wmed=[time Omega];      %Velocidade medida do degrau rad/s
Vamed=[time Va];      %Tensao de armadura Volts
Iamed=[time Ia];      %Corrente de armadura Volts