%Parameter Estimation
%Chute inicial dos parâmetros do motor
Ra = 0.1501; % Resistência de armadura [Ohm]
La = 0.000150;  % Indutância de armadura [H]
K = 0.087;  % Kt=Ke para este motor: Constante de torque [N-m/A] ou Constante f.c.e.m [V-s/rad]
J = 0.00050804; % Momento de inércia [N-m-s^2/rad]
B = 0.0006; % Coeficiente de atrito viscoso [N-m-s/rad]
Kt = K;
Ke = K;
s = tf('s');
Gm = @(Kt,Ke,Ra,La,J,B,s) Kt/(La*J*s^2+(Ra*J+La*B)*s+(Ra*B+Ke*Kt));
Gm0 = Gm(Kt,Ke,Ra,La,J,B,s);

run('SimulacaoMotorCC_r2016a');

%%
GmEstimated = Gm(Kt,Ke,Ra,La,J,B,s);

%Modo alternativo
tau_a = La/Ra;
tau_b = J/B;
tau_m = (Ra*J)/(Ke*Kt);
Gm2 = (1/(Ke*tau_m*tau_a))/(s^2 +(1/tau_a + 1/tau_b)*s + 1/(tau_m*tau_a) +1/(tau_a*tau_b) );
